final_project_giftlist/urls.py
from django.conf import settings
from django.conf.urls.static import static
from django.contrib import admin
from django.urls import include, path

from gift.views import (
    AboutView,
    login_form_view,
    logout_view,
    # user_card,
    RegisterCreateView,
    UserPageView,
    register_confirmation
)


urlpatterns = [
    path("admin/", admin.site.urls),
    path("", include("gift.urls")),
    # path("profile/", user_card, name="profile"),
    path("profile/", UserPageView.as_view(), name="profile"),
    path("login/", login_form_view, name="login"),
    path("logout/", logout_view, name="logout"),
    path("register/", RegisterCreateView.as_view(), name="register"),
    path("confirmation/<uuid:uid>", register_confirmation, name="confirmation"),
    path("about/", AboutView.as_view(), name="about"),
    path("", AboutView.as_view(), name="index"),
]

urlpatterns += static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

gift/urls.py
from django.conf import settings
from django.conf.urls.static import static
from django.urls import path

from gift.views import (
    DeleteRecordView,
    EventView,
    gift_create_view,
    gift_update_view,
    GiftView,
    person_create_view,
    person_update_view,
    PersonView,
    person_card, DeleteEventView, EventUpdateView, EventCreateView, GiftPageView,
)

app_name = "gift"
urlpatterns = [
    path("gifts/", GiftView.as_view(), name="gifts"),
    path("gift/<str:pk>/", GiftPageView.as_view(), name="gift"),
    path("gift/create/", gift_create_view, name="gift_create"),
    path("gift/update/<str:pk>/", gift_update_view, name="gift_update"),
    path("gift/delete/<str:pk>/", DeleteRecordView, name="gift_delete"),

    path("persons/", PersonView.as_view(), name="persons"),
    path("person/<str:pk>", person_card, name="person"),
    path("person/create/", person_create_view, name="person_create"),
    path("person/delete/<str:pk>/", DeleteRecordView, name="person_delete"),
    path("person/update/<str:pk>/", person_update_view, name="person_update"),
    #
    path("events", EventView.as_view(), name="events"),
    # path("event/<str:pk>/", EventPageView.as_view(), name="event"),
    path('event/create/', EventCreateView.as_view(), name='event_create'),
    path('event/update/<str:pk>/', EventUpdateView.as_view(), name='event_update'),
    path('event/delete/<str:pk>/', DeleteEventView.as_view(), name='event_delete'),
    #
    # path('profile/int:uid/', ProfileView.as_view(), name='profile'),
    # path('wishes/int:gid/', WishesView.as_view(), name='wishes'),
]

gift/forms.py
import colorfield
from colorfield import widgets
from colorfield.fields import ColorField
from colorfield.widgets import ColorWidget
from django.contrib.auth.forms import UserCreationForm
from django.contrib.auth.models import User
from django.core.exceptions import ValidationError

# from django.db.models import TextField
from django.db.transaction import atomic
from django.forms import (
    CharField,
    ChoiceField,
    DateField,
    EmailField,
    HiddenInput, ImageField,
    ModelChoiceField,
    ModelForm,
    Textarea,
)

from gift.choices import COLOR_CHOICES
from gift.models import (
    Event,
    EventType,
    Gift,
    Person,
    Relationship,
    RelationshipRequest,
)
#email sending
from django.core.mail import send_mail
from django.conf import settings

class RegisterForm(UserCreationForm):
    class Meta:
        model = User
        # fields = '__all__'
        fields = ["username", "email", "password1", "password2"]

    username = CharField(label="Uživatelské jméno", max_length=32, required=False)
    email = CharField(label="E-mail", max_length=128, required=True)
    first_name = CharField(label="Jméno", max_length=32, required=False)
    last_name = CharField(label="Příjmení", max_length=32, required=False)
    color = ColorField(choices=COLOR_CHOICES)
    about = CharField(
        label="Something about you",
        widget=Textarea,
        min_length=42,
        required=False
    )

    @atomic
    def save(self, commit=True):
        # INSERT INTO auth_user ...
        result = super().save(commit=False)
        result.is_active = False
        result = super().save(commit=True)

        person = Person(
            related_user=result,
            created_by=result,
            nickname="Já",
            #biography=self.cleaned_data["biography"],
        )
        confirmation_link = "http://localhost:8100/confirmation/" + str(person.uuid_id)
        email_subject = 'Confirm your registration'
        email_message = f'''Thank you for you registration
        Your new accout: {result.username}
        
        Please confirm activation of the account using this link:
        {confirmation_link}
        '''

        if commit:
            # INSERT INTO gift_person ...
            person.save()
            # send e-mail with confirmation link
            send_mail(
                email_subject,
                email_message,
                "confirm@slancik.eu",
                [result.email],
                fail_silently=False,
            )

        return result

class GiftForm(ModelForm):
    class Meta:
        model = Gift
        fields = '__all__'
        # fields = ['event', 'picture', 'color']
        exclude = ['created_by']

    # person = ModelChoiceField(
    #     queryset=Person.objects.filter(created_by=1), required=False
    # )
    # event = ModelChoiceField(
    #     queryset=Event.objects.filter(person__created_by=1), required=False
    # )
    person = ModelChoiceField(queryset=Person.objects, required=False)
    event = ModelChoiceField(queryset=Event.objects, required=False)
    gift_name = CharField(
        max_length=32,
        required=True
    )
    picture = ImageField(
        label='Picture',
        max_length=128,
        required=False
    )
    description = CharField(
        # default='popis',
        widget=Textarea,
        label='Popis',
        required=False,
    )
    color = ColorField(choices=COLOR_CHOICES, blank=True, editable=False)

    def clean_web_link(self):
        cleaned=self.cleaned_data['web_link']
        if cleaned:
            cleaned.lower()
            urlhead = cleaned.split("//", 1)
            if not urlhead in ["http", "https"]:
                cleaned.join("http://")
        return cleaned

class PersonForm(ModelForm):
    class Meta:
        model = Person
        fields = "__all__"
        exclude = ["created_by", "related_user"]
        # hidden = []
        # context = {'related_user_id': Person.related_user.id}


class EventForm(ModelForm):
    class Meta:
        model = Event
        fields = "__all__"
        exclude = []

    person = ModelChoiceField(
        queryset=Person.objects, required=True, show_hidden_initial=True,
        widget=HiddenInput(),
    )
    event_type = ModelChoiceField(queryset=EventType.objects, required=True)
    date = DateField(required=True)

gift/views.py
from django.contrib import (
    messages,
)  # jednorázové správy (info, success, warning, error, debug)
from django.contrib.auth import authenticate, login, logout
from django.contrib.auth.decorators import login_required
from django.contrib.auth.mixins import LoginRequiredMixin
from django.contrib.auth.models import User
from django.core.exceptions import ObjectDoesNotExist
from django.http import HttpResponseRedirect
from django.shortcuts import redirect, render
from django.urls import reverse_lazy, reverse
from django.views import View
from django.views.generic import (
    CreateView,
    DeleteView,
    ListView,
    TemplateView,
    UpdateView,
    DetailView,
)

from gift.forms import GiftForm, PersonForm, EventForm, RegisterForm
from gift.models import (
    Event,
    EventType,
    Gift,
    Person,
    Relationship,
    RelationshipRequest,
)


class GiftView(LoginRequiredMixin, ListView):
    template_name = "gift_grid.html"
    model = Gift
    # queryset = Gift.objects.filter(created_by_id=2)

    def get_queryset(self):
        queryset = super(GiftView, self).get_queryset()
        queryset = queryset.filter(created_by=self.request.user)
        return queryset


class PersonView(LoginRequiredMixin, ListView):
    template_name = "person_grid.html"
    model = Person

    def get_queryset(self):
        queryset = super(PersonView, self).get_queryset()
        queryset = queryset.filter(created_by=self.request.user)
        return queryset


class EventView(LoginRequiredMixin, ListView):
    template_name = "event_grid.html"
    model = Event

    def get_queryset(self):
        queryset = super(EventView, self).get_queryset()
        queryset = queryset.filter(person__created_by=self.request.user)
        return queryset.order_by("date")


class UserPageView(LoginRequiredMixin, ListView):
    template_name = "user_page.html"
    model = Gift

    def get_queryset(self):
        queryset = super(UserPageView, self).get_queryset()
        # queryset = queryset.filter(gift__created_by=self.request.user)
        queryset = queryset.filter(person__related_user=self.request.user)
        return queryset

# def user_card(request):
#     if not request.user.is_authenticated:
#         return redirect("login")
#     return render(request, template_name="user_page.html")


@login_required
def person_card(request, pk):
    record = Person.objects.get(id=pk)
    context = {"person": record}
    return render(request, "person_page.html", context)


class GiftPageView(DetailView):
    model = Gift
    template_name = "gift_page.html"


class AboutView(TemplateView):
    # page = 'about'
    template_name = "about.html"


def login_form_view(request):
    if request.user.is_authenticated:
        messages.info(request, "You are already logged in as " + request.user.username)
        return redirect("profile")

    if request.method == "POST":
        user_name = request.POST["username"].lower()
        pwd = request.POST["password"]

        try:
            user = User.objects.get(username=user_name)
        except:
            messages.error(request, "Username does not exist")

        user = authenticate(request, username=user_name, password=pwd)
        if user is not None:
            login(request, user)
            messages.success(request, "You are succefully logged in.")
            return redirect("gift:gifts")
        else:
            messages.error(request, "Username or password is incorrect")

    return render(request, "login_form.html")


def logout_view(request):
    logout(request)
    return redirect("login")


def register_confirmation(request, uid):
    try:
        search = Person.objects.get(uuid_id=uid)
    except ObjectDoesNotExist:
        search = False
        messages.error(request, f"invalid activation link")

    if search:
        print("is person")
        confirmed_user = User.objects.get(id=search.related_user.id)
        if confirmed_user.is_active:
            messages.warning(request, "Your account was already activated.")
        else:
            confirmed_user.is_active = True
            confirmed_user.save()
            # POZOR pri deaktivovaní - treba zmeniť uuid viazanej osoby, aby
            # užívateľ nemohol opätovne použiť linku z mailu
            # person.uuid_id = uuid4()
            # person.save()

            messages.success(request, "Your account is now active.")

    return HttpResponseRedirect(reverse("login"))


# CREATE VIEWS
class RegisterCreateView(CreateView):
    template_name = 'register_form.html'
    form_class = RegisterForm
    success_url = reverse_lazy('login')

    def form_valid(self, form):
        if form.is_valid():
            form.save()
            messages.success(self.request, "Registration succeeded! Confirmation mail was sent.")
        else:
            messages.warning(self.request, "Registration failed!")
        return redirect('login')

    def get_object(self, queryset=None):
        return self.request.user

    def get_initial(self):
        results = super().get_initial()
        results["person"] = Person()
        # results["permanent_address"] = self.request.user.profile.permanent_address
        return results



# @login_required
# def GiftCreateView(request):
#     record = request.POST
#     form = GiftForm(record, request.FILES)
#     form.instance.created_by = request.user
#     messages.info(request, str(form.instance.picture))
#
#     if form.is_valid():
#         form.save()
#         messages.success(request, "New gift was created")
#         return redirect("gift:gifts")
#
#     context = {"form": form, "picture_url": form.instance.picture.url}
#     return render(request, "gift_form.html", context)
#
#     # def form_valid(self, form):
#     #     form.instance.created_by = self.request.user
#     #     return super().form_valid(form)


@login_required
def gift_create_view(request):
    if request.method == 'GET':
        form = GiftForm()
        form.fields['person'].queryset = Person.objects.filter(
            created_by=request.user)
        form.fields['event'].queryset = Event.objects.filter(
            person__created_by=request.user)

        context = {'form': form}
        return render(request, "gift_form.html", context)

    elif request.method == 'POST':
        form = GiftForm(data=request.POST, files=request.FILES)
        form.instance.created_by = request.user
        context = {'form': form}

        if form.is_valid():
            form.save()
            messages.success(request, "New gift was created")
            return redirect('gift:gifts')
        else:
            return render(request, "gift_form.html", context)

    return redirect('gift:gifts')


@login_required
def person_create_view(request):
    record = request.POST
    form = PersonForm(record, request.FILES)
    form.instance.created_by = request.user
    messages.info(request, str(form.instance.picture))

    if form.is_valid():
        form.save()
        messages.success(request, "New person was created")
        return redirect("gift:persons")

    context = {"form": form, "picture_url": form.instance.picture.url}
    return render(request, "person_form.html", context)


class EventCreateView(LoginRequiredMixin, CreateView):
    template_name = 'form.html'
    form_class = EventForm
    success_url = reverse_lazy('gift:events')

    def get_initial(self):
        output = super().get_initial()
        output["person"] = Person.objects.get(id=self.request.GET["person_id"])
        return output

    # def get_form_kwargs(self):
    #     kwargs = super().get_form_kwargs()
    #     kwargs['person'] = Person.objects.get(id=pk)
    #     return kwargs


# UPDATE VIEWS
@login_required
def gift_update_view(request, pk):
    record = Gift.objects.get(id=pk)
    form = GiftForm(instance=record)

    if request.method == 'GET':
        form.fields['person'].queryset = Person.objects.filter(
            created_by=request.user)
        form.fields['event'].queryset = Event.objects.filter(
            person__created_by=request.user)

    if request.method == "POST":
        form = GiftForm(request.POST, request.FILES, instance=record)
        if form.is_valid():
            form.save()
            messages.success(request, "Gift changes was saved")
            return redirect("gift:gifts")
        else:
            messages.error(request, 'Error saving form')

    context = {"form": form, "pk": pk, "picture_url": record.picture.url}
    return render(request, "gift_form.html", context)


@login_required
def person_update_view(request, pk):
    record = Person.objects.get(id=pk)
    form = PersonForm(instance=record)

    if request.method == "POST":
        form = PersonForm(request.POST, request.FILES, instance=record)
        if form.is_valid():
            form.save()
            messages.success(request, "Gift changes was saved")
            return redirect("gift:persons")

    context = {"form": form, "pk": pk, "picture_url": record.picture.url, "can_delete": record.deletable}
    return render(request, "person_form.html", context)


class EventUpdateView(LoginRequiredMixin, UpdateView):
    template_name = 'form.html'
    model = Event
    form_class = EventForm
    success_url = reverse_lazy('gift:events')

    # def get_context_data(self):
    #     return

    # def get_queryset(self):
    #     queryset = super(EventUpdateView, self).get_queryset()
    #     form.fields['event'].queryset = Event.objects.filter(
    #         person__created_by=request.user)
    #     event.queryset = queryset.filter(person__created_by=self.request.user)
    #     queryset['event_type'] = queryset['event_type'].filter()
    #     return queryset


# DELETE VIEWS
@login_required
def DeleteRecordView(request, pk):
    record = Gift.objects.get(id=pk)

    if request.method == "POST":
        form = GiftForm(request.POST, instance=record)
        if form.is_valid():
            record.delete()

gift/templates/delete_confirmation.html
{% extends 'base.html' %}

{% block content %}

    <form action="" method="POST">
        {% csrf_token %}

        <p>Are you sure to delete "{{ object }}"?</p>
        <a href="{% url 'gift:gift_create' %}">
            Back
        </a>
        <input class="btn-warning" type="submit" value="Confirm">
    </form>

{% endblock %}

gift/templates/event_card.html
<article>
    <h2>Event {{ event.event_type.event_type_name }} of {{ event.person.nickname }}</h2>
    <ul color="{{ event.color }}">
        <li>About: </li>
        <li>{{ event.about }}</li>
        <li><a href="{% url 'gift:event_update' person.id %}">Edit event</a></li>
    </ul>
</article>

gift/templates/event_comfirm_delete.html
{% extends "base.html" %}

{% block content %}
    <form method="POST">
        {% csrf_token %}
        <p>Are you sure want to delete event <b>{{ object }}</b> from database?</p>
        <input type="submit" value="Submit" class="btn btn-danger">
{#        <a href="{% url 'gift:event_create' %}">Back</a>#}
    </form>
{% endblock %}

gift/templates/form.html
{% extends "base.html" %}

{% block content %}
    <form method="POST">
    {% csrf_token %}
    <table>{{ form }}</table>
    <input type="submit" value="Submit" class="btn btn-info">
    </form>
{% endblock %}

gift/templates/gift_form.html
{% extends 'base.html' %}

{% block content %}
    <script src="/static/colorfield/jscolor/jscolor.js"></script>



    <form method="POST" enctype="multipart/form-data">
        {% csrf_token %}
        <table>
            <tr>
                <th colspan="2"><h2>{{  form.gift_name.value }}</h2></th>

            </tr>
            {{ form }}
            <tr>
                <th><label>Color</label></th>
                <td>{% include 'color_pick.html' %}</td>
            </tr>
            <tr>
                <td><input type="submit" value="Submit" class="btn btn-info"></td>
                <td>
                    <a class="btn btn-danger " href="{% url 'gift:gift_delete' pk %}">
                    Delete gift
                    </a>
                </td>
            </tr>
        </table>
    </form>


{% endblock %}

gift/templates/gift_grid_card.html
        <ul>
            {% for object in object_list %}
                <a href="{% url 'gift:gift' object.id %}" title="{{ object.gift_name }}">
                    <li>
                        <div class="object-wrapper jumbotron label-flex box-shadow" style="border-color: {{ object.color }}">
                            <span class="color-strip" style="background-color: {{ object.color }}"></span>
                            <span>
                                <img src="{% if object.picture %}
                                          {{ object.picture.url }}
                                          {% else %}
                                          /img/default_gift.gif
                                          {% endif %}"
                                     alt="Picture of gift {{ object.id }}"
                                >
                                    {{ object.name_label }}
                                    {% if object.person %}
                                    for {{ object.person.nickname }}
                                    {% endif %}
                            </span>
                        </div>
                    </li>
                </a>
            {% endfor %}
        </ul>

gift/templates/gift_page.html
{% extends 'base.html' %}

{% block content %}

{% include 'gift_card.html' %}

{% endblock %}

gift/templates/old_gift_form.html
{% extends 'base.html' %}


{% block content %}
    <script src="/static/colorfield/jscolor/jscolor.js"></script>
    <h2>Edit gift {{ form.gift_name.value }}</h2>

    <form method="POST">
        {%  csrf_token %}

        <table>

            {% for field in form %}
            <tr>

                <td><p>{{ field.label }}:</p> </td>
                <td><p>{{ field }}</p></td>
            </tr>
            <tr>
                <td></td>
                <td>{{ field.errors }}</td>
            </tr>
            <tr>
                {% if field.label == "Picture" and field %}
                    <td></td>
                    <td><img src="{{ picture_url }}"></td>
                {% endif %}
            </tr>
            {% endfor %}
            <tr>
                <td><input type="submit" value="Confirm" class="btn btn-secondary"></td>
                <td>
                {% if pk %}
                    <a href="{% url 'gift:gift_delete' pk %}">
                    Delete gift
                    </a>
                {% else %}
                    <p> </p>
                {% endif %}
                </td>
            </tr>
        </table>
    </form>

{% endblock %}

gift/templates/person.html
{% extends "base.html" %}

{% block content %}
    <h1>Person</h1>
{% endblock %}

gift/templates/person_card.html
<article>
    <a href="{% url 'gift:person_update' person.id %}">
        <h2 style="color:{{ person.color }}; display:flex"><span>{{ person.nickname }}</span><span class="edit-index-to-header"> EDIT</span></h2>
    </a>
    <ul color="{{ person.color }}">
        <li>About: </li>
        <li>{{ person.about }}</li>
        <li></li>
        <li> <a href="{% url 'gift:event_create' %}?person_id={{ person.id }}" class="btn">+ Add event</a></li>
        <li>
            {% if person.deletable %}
{#                <a href="{% url 'gift:person_delete' pk %}">#}
                Delete person
                </a>
            {% endif %}
        </li>
    </ul>
</article>

gift/templates/person_form.html
{% extends 'base.html' %}


{% block content %}
    <script src="/static/colorfield/jscolor/jscolor.js"></script>
    <h2>Edit person {{ form.nickname.value }}</h2>

    <form method="POST">
        {%  csrf_token %}

        <table>

            {% for field in form %}
            <tr>

                <td><p>{{ field.label }}:</p> </td>
                <td><p>{{ field }}</p></td>
            </tr>
            <tr>
                {% if field.label == "Picture" and field %}
                    <td></td>
                    <td><img src="{{ picture_url }}"></td>
                {% endif %}
            </tr>
            {% endfor %}
            <tr>
                <td><input type="submit" value="Confirm" class="btn btn-secondary"></td>
                <td>
                {% if can_delete %}
                    <a href="{% url 'gift:person_delete' pk %}">
                    Delete person
                    </a>
                {% endif %}
                </td>
            </tr>
        </table>
    </form>

{% endblock %}

gift/templates/person_page.html
{% extends 'base.html' %}

{% block content %}

{% include 'person_card.html' %}

{% endblock %}

gift/templates/user_card.html
<article>
    <h2>User {{ request.user.username }}</h2>
    <ul>
        <li>Name: {{ request.user.first_name }} {{ request.user.last_name }}</li>
        <li>E-mail: {{ request.user.email }}</li>
    </ul>
</article>

gift/templates/user_page.html
{% extends 'base.html' %}

{% block content %}

{% include 'user_card.html' %}

    <h3>Wishes</h3>

{% include 'gift_grid_card.html' %}

{% endblock %}